## GDateTime GDateTime — a structure representing Date and Time |

## Functions

void | g_date_time_unref ()
GDateTime * | g_date_time_ref ()
GDateTime * | g_date_time_new_now ()
GDateTime * | g_date_time_new_now_local ()
GDateTime * | g_date_time_new_now_utc ()
GDateTime * | g_date_time_new_from_unix_local ()
GDateTime * | g_date_time_new_from_unix_utc ()
GDateTime * | g_date_time_new_from_timeval_local ()
GDateTime * | g_date_time_new_from_timeval_utc ()
GDateTime * | g_date_time_new_from_iso8601 ()
GDateTime * | g_date_time_new ()
GDateTime * | g_date_time_new_local ()
GDateTime * | g_date_time_new_utc ()
GDateTime * | g_date_time_add ()
GDateTime * | g_date_time_add_years ()
GDateTime * | g_date_time_add_months ()
GDateTime * | g_date_time_add_weeks ()
GDateTime * | g_date_time_add_days ()
GDateTime * | g_date_time_add_hours ()
GDateTime * | g_date_time_add_minutes ()
GDateTime * | g_date_time_add_seconds ()
GDateTime * | g_date_time_add_full ()
gint | g_date_time_compare ()
GTimeSpan | g_date_time_difference ()
guint | g_date_time_hash ()
gboolean | g_date_time_equal ()
void | g_date_time_get_ymd ()
gint | g_date_time_get_year ()
gint | g_date_time_get_month ()
gint | g_date_time_get_day_of_month ()
gint | g_date_time_get_week_numbering_year ()
gint | g_date_time_get_week_of_year ()
gint | g_date_time_get_day_of_week ()
gint | g_date_time_get_day_of_year ()
gint | g_date_time_get_hour ()
gint | g_date_time_get_minute ()
gint | g_date_time_get_second ()
gint | g_date_time_get_microsecond ()
gdouble | g_date_time_get_seconds ()
gint64 | g_date_time_to_unix ()
gboolean | g_date_time_to_timeval ()
GTimeSpan | g_date_time_get_utc_offset ()
GTimeZone * | g_date_time_get_timezone ()
const gchar * | g_date_time_get_timezone_abbreviation ()
gboolean | g_date_time_is_daylight_savings ()
GDateTime * | g_date_time_to_timezone ()
GDateTime * | g_date_time_to_local ()
GDateTime * | g_date_time_to_utc ()
gchar * | g_date_time_format ()
gchar * | g_date_time_format_iso8601 ()

## Types and Values

typedef | GTimeSpan
#define | G_TIME_SPAN_DAY
#define | G_TIME_SPAN_HOUR
#define | G_TIME_SPAN_MINUTE
#define | G_TIME_SPAN_SECOND
#define | G_TIME_SPAN_MILLISECOND
| GDateTime

## Includes

    #include <glib.h>
    #include <glib/gprintf.h>

## Description

GDateTime is a structure that combines a Gregorian date and time into a single structure. It provides many conversion and methods to manipulate dates and times. Time precision is provided down to microseconds and the time can range (proleptically) from 0001-01-01 00:00:00 to 9999-12-31 23:59:59.999999. GDateTime follows POSIX time in the sense that it is oblivious to leap seconds.

GDateTime is an immutable object; once it has been created it cannot be modified further. All modifiers will create a new GDateTime. Nearly all such functions can fail due to the date or time going out of range, in which case `NULL` will be returned.

GDateTime is reference counted: the reference count is increased by calling `g_date_time_ref()` and decreased by calling `g_date_time_unref()`. When the reference count drops to 0, the resources allocated by the GDateTime structure are released.

Many parts of the API may produce non-obvious results. As an example, adding two months to January 31st will yield March 31st whereas adding one month and then one month again will yield either March 28th or March 29th. Also note that adding 24 hours is not always the same as adding one day (since days containing daylight savings time transitions are either 23 or 25 hours in length).

GDateTime is available since GLib 2.26.

## Functions

### g_date_time_unref ()

    void
    g_date_time_unref (GDateTime *datetime);

Atomically decrements the reference count of `datetime` by one.

When the reference count reaches zero, the resources allocated by `datetime` are freed

#### Parameters

datetime | a GDateTime |

Since: 2.26

### g_date_time_ref ()

    GDateTime *
    g_date_time_ref (GDateTime *datetime);

Atomically increments the reference count of `datetime` by one.

#### Parameters

datetime | a GDateTime |

#### Returns

the GDateTime with the reference count increased

Since: 2.26

### g_date_time_new_now ()

    GDateTime *
    g_date_time_new_now (GTimeZone *tz);

Creates a GDateTime corresponding to this exact instant in the given time zone `tz` . The time is as accurate as the system allows, to a maximum accuracy of 1 microsecond.

This function will always succeed unless GLib is still being used after the year 9999.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

tz | a GTimeZone |

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_now_local ()

    GDateTime *
    g_date_time_new_now_local (void);

Creates a GDateTime corresponding to this exact instant in the local time zone.

This is equivalent to calling `g_date_time_new_now()` with the time zone returned by `g_time_zone_new_local()`.

[constructor]

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_now_utc ()

    GDateTime *
    g_date_time_new_now_utc (void);

Creates a GDateTime corresponding to this exact instant in UTC.

This is equivalent to calling `g_date_time_new_now()` with the time zone returned by `g_time_zone_new_utc()`.

[constructor]

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_from_unix_local ()

    GDateTime *
    g_date_time_new_from_unix_local (gint64 t);

Creates a GDateTime corresponding to the given Unix time `t` in the local time zone.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC, regardless of the local time offset.

This call can fail (returning `NULL`) if `t` represents a time outside of the supported range of GDateTime.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

t | the Unix time |

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_from_unix_utc ()

    GDateTime *
    g_date_time_new_from_unix_utc (gint64 t);

Creates a GDateTime corresponding to the given Unix time `t` in UTC.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC.

This call can fail (returning `NULL`) if `t` represents a time outside of the supported range of GDateTime.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

t | the Unix time |

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_from_timeval_local ()

    GDateTime *
    g_date_time_new_from_timeval_local (const GTimeVal *tv);

`g_date_time_new_from_timeval_local` has been deprecated since version 2.62 and should not be used in newly-written code.

GTimeVal is not year-2038-safe. Use `g_date_time_new_from_unix_local()` instead.

Creates a GDateTime corresponding to the given GTimeVal `tv` in the local time zone.

The time contained in a GTimeVal is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC, regardless of the local time offset.

This call can fail (returning `NULL`) if `tv` represents a time outside of the supported range of GDateTime.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

tv | a GTimeVal |

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_from_timeval_utc ()

    GDateTime *
    g_date_time_new_from_timeval_utc (const GTimeVal *tv);

`g_date_time_new_from_timeval_utc` has been deprecated since version 2.62 and should not be used in newly-written code.

GTimeVal is not year-2038-safe. Use `g_date_time_new_from_unix_utc()` instead.

Creates a GDateTime corresponding to the given GTimeVal `tv` in UTC.

The time contained in a GTimeVal is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC.

This call can fail (returning `NULL`) if `tv` represents a time outside of the supported range of GDateTime.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

tv | a GTimeVal |

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_from_iso8601 ()

    GDateTime *
    g_date_time_new_from_iso8601 (const gchar *text,
                                  GTimeZone *default_tz);

Creates a GDateTime corresponding to the given ISO 8601 formatted string `text` . ISO 8601 strings of the form <date><sep><time><tz> are supported, with some extensions from RFC 3339 as mentioned below.

Note that as GDateTime "is oblivious to leap seconds", leap seconds information in an ISO-8601 string will be ignored, so a `23:59:60` time would be parsed as `23:59:59`.

<sep> is the separator and can be either 'T', 't' or ' '. The latter two separators are an extension from RFC 3339.

<date> is in the form:

- `YYYY-MM-DD` - Year/month/day, e.g. 2016-08-24.

- `YYYYMMDD` - Same as above without dividers.

- `YYYY-DDD` - Ordinal day where DDD is from 001 to 366, e.g. 2016-237.

- `YYYYDDD` - Same as above without dividers.

- `YYYY-Www-D` - Week day where ww is from 01 to 52 and D from 1-7, e.g. 2016-W34-3.

- `YYYYWwwD` - Same as above without dividers.

<time> is in the form:

- `hh:mm:ss(.sss)` - Hours, minutes, seconds (subseconds), e.g. 22:10:42.123.

- `hhmmss(.sss)` - Same as above without dividers.

<tz> is an optional timezone suffix of the form:

- `Z` - UTC.

- `+hh:mm` or `-hh:mm` - Offset from UTC in hours and minutes, e.g. +12:00.

- `+hh` or `-hh` - Offset from UTC in hours, e.g. +12.

If the timezone is not provided in `text` it must be provided in `default_tz` (this field is otherwise ignored).

This call can fail (returning `NULL`) if `text` is not a valid ISO 8601 formatted string.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

text | an ISO 8601 formatted time string. |
default_tz | a GTimeZone to use if the text doesn't contain a timezone, or `NULL`. | [nullable]

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.56

### g_date_time_new ()

    GDateTime *
    g_date_time_new (GTimeZone *tz,
                     gint year,
                     gint month,
                     gint day,
                     gint hour,
                     gint minute,
                     gdouble seconds);

Creates a new GDateTime corresponding to the given date and time in the time zone `tz` .

The `year` must be between 1 and 9999, `month` between 1 and 12 and `day` between 1 and 28, 29, 30 or 31 depending on the month and the year.

`hour` must be between 0 and 23 and `minute` must be between 0 and 59.

`seconds` must be at least 0.0 and must be strictly less than 60.0. It will be rounded down to the nearest microsecond.

If the given time is not representable in the given time zone (for example, 02:30 on March 14th 2010 in Toronto, due to daylight savings time) then the time will be rounded up to the nearest existing time (in this case, 03:00). If this matters to you then you should verify the return value for containing the same as the numbers you gave.

In the case that the given time is ambiguous in the given time zone (for example, 01:30 on November 7th 2010 in Toronto, due to daylight savings time) then the time falling within standard (ie: non-daylight) time is taken.

It not considered a programmer error for the values to this function to be out of range, but in the case that they are, the function will return `NULL`.

You should release the return value by calling `g_date_time_unref()` when you are done with it.

[constructor]

#### Parameters

tz | a GTimeZone |
year | the year component of the date |
month | the month component of the date |
day | the day component of the date |
hour | the hour component of the date |
minute | the minute component of the date |
seconds | the number of seconds past the minute |

#### Returns

a new GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_local ()

    GDateTime *
    g_date_time_new_local (gint year,
                           gint month,
                           gint day,
                           gint hour,
                           gint minute,
                           gdouble seconds);

Creates a new GDateTime corresponding to the given date and time in the local time zone.

This call is equivalent to calling `g_date_time_new()` with the time zone returned by `g_time_zone_new_local()`.

[constructor]

#### Parameters

year | the year component of the date |
month | the month component of the date |
day | the day component of the date |
hour | the hour component of the date |
minute | the minute component of the date |
seconds | the number of seconds past the minute |

#### Returns

a GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_new_utc ()

    GDateTime *
    g_date_time_new_utc (gint year,
                         gint month,
                         gint day,
                         gint hour,
                         gint minute,
                         gdouble seconds);

Creates a new GDateTime corresponding to the given date and time in UTC.

This call is equivalent to calling `g_date_time_new()` with the time zone returned by `g_time_zone_new_utc()`.

[constructor]

#### Parameters

year | the year component of the date |
month | the month component of the date |
day | the day component of the date |
hour | the hour component of the date |
minute | the minute component of the date |
seconds | the number of seconds past the minute |

#### Returns

a GDateTime, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add ()

    GDateTime *
    g_date_time_add (GDateTime *datetime,
                     GTimeSpan timespan);

Creates a copy of `datetime` and adds the specified timespan to the copy.

#### Parameters

datetime | a GDateTime |
timespan | a GTimeSpan |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_years ()

    GDateTime *
    g_date_time_add_years (GDateTime *datetime,
                           gint years);

Creates a copy of `datetime` and adds the specified number of years to the copy. Add negative values to subtract years.

As with `g_date_time_add_months()`, if the resulting date would be 29th February on a non-leap year, the day will be clamped to 28th February.

#### Parameters

datetime | a GDateTime |
years | the number of years |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_months ()

    GDateTime *
    g_date_time_add_months (GDateTime *datetime,
                            gint months);

Creates a copy of `datetime` and adds the specified number of months to the copy. Add negative values to subtract months.

The day of the month of the resulting GDateTime is clamped to the number of days in the updated calendar month. For example, if adding 1 month to 31st January 2018, the result would be 28th February 2018. In 2020 (a leap year), the result would be 29th February.

#### Parameters

datetime | a GDateTime |
months | the number of months |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_weeks ()

    GDateTime *
    g_date_time_add_weeks (GDateTime *datetime,
                           gint weeks);

Creates a copy of `datetime` and adds the specified number of weeks to the copy. Add negative values to subtract weeks.

#### Parameters

datetime | a GDateTime |
weeks | the number of weeks |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_days ()

    GDateTime *
    g_date_time_add_days (GDateTime *datetime,
                          gint days);

Creates a copy of `datetime` and adds the specified number of days to the copy. Add negative values to subtract days.

#### Parameters

datetime | a GDateTime |
days | the number of days |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_hours ()

    GDateTime *
    g_date_time_add_hours (GDateTime *datetime,
                           gint hours);

Creates a copy of `datetime` and adds the specified number of hours. Add negative values to subtract hours.

#### Parameters

datetime | a GDateTime |
hours | the number of hours to add |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_minutes ()

    GDateTime *
    g_date_time_add_minutes (GDateTime *datetime,
                             gint minutes);

Creates a copy of `datetime` adding the specified number of minutes. Add negative values to subtract minutes.

#### Parameters

datetime | a GDateTime |
minutes | the number of minutes to add |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_seconds ()

    GDateTime *
    g_date_time_add_seconds (GDateTime *datetime,
                             gdouble seconds);

Creates a copy of `datetime` and adds the specified number of seconds. Add negative values to subtract seconds.

#### Parameters

datetime | a GDateTime |
seconds | the number of seconds to add |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_add_full ()

    GDateTime *
    g_date_time_add_full (GDateTime *datetime,
                          gint years,
                          gint months,
                          gint days,
                          gint hours,
                          gint minutes,
                          gdouble seconds);

Creates a new GDateTime adding the specified values to the current date and time in `datetime` . Add negative values to subtract.

#### Parameters

datetime | a GDateTime |
years | the number of years to add |
months | the number of months to add |
days | the number of days to add |
hours | the number of hours to add |
minutes | the number of minutes to add |
seconds | the number of seconds to add |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_compare ()

    gint
    g_date_time_compare (gconstpointer dt1,
                         gconstpointer dt2);

A comparison function for GDateTimes that is suitable as a GCompareFunc. Both GDateTimes must be non-`NULL`.

#### Parameters

dt1 | first GDateTime to compare. | [type GDateTime][not nullable]
dt2 | second GDateTime to compare. | [type GDateTime][not nullable]

#### Returns

-1, 0 or 1 if `dt1` is less than, equal to or greater than `dt2` .

Since: 2.26

### g_date_time_difference ()

    GTimeSpan
    g_date_time_difference (GDateTime *end,
                            GDateTime *begin);

Calculates the difference in time between `end` and `begin` . The GTimeSpan that is returned is effectively `end` - `begin` (ie: positive if the first parameter is larger).

#### Parameters

end | a GDateTime |
begin | a GDateTime |

#### Returns

the difference between the two GDateTime, as a time span expressed in microseconds.

Since: 2.26

### g_date_time_hash ()

    guint
    g_date_time_hash (gconstpointer datetime);

Hashes `datetime` into a guint, suitable for use within GHashTable.

#### Parameters

datetime | a GDateTime. | [type GDateTime][not nullable]

#### Returns

a guint containing the hash

Since: 2.26

### g_date_time_equal ()

    gboolean
    g_date_time_equal (gconstpointer dt1,
                       gconstpointer dt2);

Checks to see if `dt1` and `dt2` are equal.

Equal here means that they represent the same moment after converting them to the same time zone.

#### Parameters

dt1 | a GDateTime. | [type GDateTime][not nullable]
dt2 | a GDateTime. | [type GDateTime][not nullable]

#### Returns

`TRUE` if `dt1` and `dt2` are equal

Since: 2.26

### g_date_time_get_ymd ()

    void
    g_date_time_get_ymd (GDateTime *datetime,
                         gint *year,
                         gint *month,
                         gint *day);

Retrieves the Gregorian day, month, and year of a given GDateTime.

#### Parameters

datetime | a GDateTime. |
year | the return location for the gregorian year, or `NULL`. | [out][optional]
month | the return location for the month of the year, or `NULL`. | [out][optional]
day | the return location for the day of the month, or `NULL`. | [out][optional]

Since: 2.26

### g_date_time_get_year ()

    gint
    g_date_time_get_year (GDateTime *datetime);

Retrieves the year represented by `datetime` in the Gregorian calendar.

#### Parameters

datetime | A GDateTime |

#### Returns

the year represented by `datetime`

Since: 2.26

### g_date_time_get_month ()

    gint
    g_date_time_get_month (GDateTime *datetime);

Retrieves the month of the year represented by `datetime` in the Gregorian calendar.

#### Parameters

datetime | a GDateTime |

#### Returns

the month represented by `datetime`

Since: 2.26

### g_date_time_get_day_of_month ()

    gint
    g_date_time_get_day_of_month (GDateTime *datetime);

Retrieves the day of the month represented by `datetime` in the gregorian calendar.

#### Parameters

datetime | a GDateTime |

#### Returns

the day of the month

Since: 2.26

### g_date_time_get_week_numbering_year ()

    gint
    g_date_time_get_week_numbering_year (GDateTime *datetime);

Returns the ISO 8601 week-numbering year in which the week containing `datetime` falls.

This function, taken together with `g_date_time_get_week_of_year()` and `g_date_time_get_day_of_week()` can be used to determine the full ISO week date on which `datetime` falls.

This is usually equal to the normal Gregorian year (as returned by `g_date_time_get_year()`), except as detailed below:

For Thursday, the week-numbering year is always equal to the usual calendar year. For other days, the number is such that every day within a complete week (Monday to Sunday) is contained within the same week-numbering year.

For Monday, Tuesday and Wednesday occurring near the end of the year, this may mean that the week-numbering year is one greater than the calendar year (so that these days have the same week-numbering year as the Thursday occurring early in the next year).

For Friday, Saturday and Sunday occurring near the start of the year, this may mean that the week-numbering year is one less than the calendar year (so that these days have the same week-numbering year as the Thursday occurring late in the previous year).

An equivalent description is that the week-numbering year is equal to the calendar year containing the majority of the days in the current week (Monday to Sunday).

Note that January 1 0001 in the proleptic Gregorian calendar is a Monday, so this function never returns 0.

#### Parameters

datetime | a GDateTime |

#### Returns

the ISO 8601 week-numbering year for `datetime`

Since: 2.26

### g_date_time_get_week_of_year ()

    gint
    g_date_time_get_week_of_year (GDateTime *datetime);

Returns the ISO 8601 week number for the week containing `datetime` . The ISO 8601 week number is the same for every day of the week (from Moday through Sunday). That can produce some unusual results (described below).

The first week of the year is week 1. This is the week that contains the first Thursday of the year. Equivalently, this is the first week that has more than 4 of its days falling within the calendar year.

The value 0 is never returned by this function. Days contained within a year but occurring before the first ISO 8601 week of that year are considered as being contained in the last week of the previous year. Similarly, the final days of a calendar year may be considered as being part of the first ISO 8601 week of the next year if 4 or more days of that week are contained within the new year.

#### Parameters

datetime | a GDateTime |

#### Returns

the ISO 8601 week number for `datetime` .

Since: 2.26

### g_date_time_get_day_of_week ()

    gint
    g_date_time_get_day_of_week (GDateTime *datetime);

Retrieves the ISO 8601 day of the week on which `datetime` falls (1 is Monday, 2 is Tuesday... 7 is Sunday).

#### Parameters

datetime | a GDateTime |

#### Returns

the day of the week

Since: 2.26

### g_date_time_get_day_of_year ()

    gint
    g_date_time_get_day_of_year (GDateTime *datetime);

Retrieves the day of the year represented by `datetime` in the Gregorian calendar.

#### Parameters

datetime | a GDateTime |

#### Returns

the day of the year

Since: 2.26

### g_date_time_get_hour ()

    gint
    g_date_time_get_hour (GDateTime *datetime);

Retrieves the hour of the day represented by `datetime`

#### Parameters

datetime | a GDateTime |

#### Returns

the hour of the day

Since: 2.26

### g_date_time_get_minute ()

    gint
    g_date_time_get_minute (GDateTime *datetime);

Retrieves the minute of the hour represented by `datetime`

#### Parameters

datetime | a GDateTime |

#### Returns

the minute of the hour

Since: 2.26

### g_date_time_get_second ()

    gint
    g_date_time_get_second (GDateTime *datetime);

Retrieves the second of the minute represented by `datetime`

#### Parameters

datetime | a GDateTime |

#### Returns

the second represented by `datetime`

Since: 2.26

### g_date_time_get_microsecond ()

    gint
    g_date_time_get_microsecond (GDateTime *datetime);

Retrieves the microsecond of the date represented by `datetime`

#### Parameters

datetime | a GDateTime |

#### Returns

the microsecond of the second

Since: 2.26

### g_date_time_get_seconds ()

    gdouble
    g_date_time_get_seconds (GDateTime *datetime);

Retrieves the number of seconds since the start of the last minute, including the fractional part.

#### Parameters

datetime | a GDateTime |

#### Returns

the number of seconds

Since: 2.26

### g_date_time_to_unix ()

    gint64
    g_date_time_to_unix (GDateTime *datetime);

Gives the Unix time corresponding to `datetime` , rounding down to the nearest second.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC, regardless of the time zone associated with `datetime` .

#### Parameters

datetime | a GDateTime |

#### Returns

the Unix time corresponding to `datetime`

Since: 2.26

### g_date_time_to_timeval ()

    gboolean
    g_date_time_to_timeval (GDateTime *datetime,
                            GTimeVal *tv);

`g_date_time_to_timeval` has been deprecated since version 2.62 and should not be used in newly-written code.

GTimeVal is not year-2038-safe. Use `g_date_time_to_unix()` instead.

Stores the instant in time that `datetime` represents into `tv` .

The time contained in a GTimeVal is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC, regardless of the time zone associated with `datetime` .

On systems where 'long' is 32bit (ie: all 32bit systems and all Windows systems), a GTimeVal is incapable of storing the entire range of values that GDateTime is capable of expressing. On those systems, this function returns `FALSE` to indicate that the time is out of range.

On systems where 'long' is 64bit, this function never fails.

#### Parameters

datetime | a GDateTime |
tv | a GTimeVal to modify |

#### Returns

`TRUE` if successful, else `FALSE`

Since: 2.26

### g_date_time_get_utc_offset ()

    GTimeSpan
    g_date_time_get_utc_offset (GDateTime *datetime);

Determines the offset to UTC in effect at the time and in the time zone of `datetime` .

The offset is the number of microseconds that you add to UTC time to arrive at local time for the time zone (ie: negative numbers for time zones west of GMT, positive numbers for east).

If `datetime` represents UTC time, then the offset is always zero.

#### Parameters

datetime | a GDateTime |

#### Returns

the number of microseconds that should be added to UTC to get the local time

Since: 2.26

### g_date_time_get_timezone ()

    GTimeZone *
    g_date_time_get_timezone (GDateTime *datetime);

Get the time zone for this `datetime` .

#### Parameters

datetime | a GDateTime |

#### Returns

the time zone.

[transfer none]

Since: 2.58

### g_date_time_get_timezone_abbreviation ()

    const gchar *
    g_date_time_get_timezone_abbreviation (GDateTime *datetime);

Determines the time zone abbreviation to be used at the time and in the time zone of `datetime` .

For example, in Toronto this is currently "EST" during the winter months and "EDT" during the summer months when daylight savings time is in effect.

#### Parameters

datetime | a GDateTime |

#### Returns

the time zone abbreviation. The returned string is owned by the GDateTime and it should not be modified or freed.

[transfer none]

Since: 2.26

### g_date_time_is_daylight_savings ()

    gboolean
    g_date_time_is_daylight_savings (GDateTime *datetime);

Determines if daylight savings time is in effect at the time and in the time zone of `datetime` .

#### Parameters

datetime | a GDateTime |

#### Returns

`TRUE` if daylight savings time is in effect

Since: 2.26

### g_date_time_to_timezone ()

    GDateTime *
    g_date_time_to_timezone (GDateTime *datetime,
                             GTimeZone *tz);

Create a new GDateTime corresponding to the same instant in time as `datetime` , but in the time zone `tz` .

This call can fail in the case that the time goes out of bounds. For example, converting 0001-01-01 00:00:00 UTC to a time zone west of Greenwich will fail (due to the year 0 being out of range).

#### Parameters

datetime | a GDateTime |
tz | the new GTimeZone |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_to_local ()

    GDateTime *
    g_date_time_to_local (GDateTime *datetime);

Creates a new GDateTime corresponding to the same instant in time as `datetime` , but in the local time zone.

This call is equivalent to calling `g_date_time_to_timezone()` with the time zone returned by `g_time_zone_new_local()`.

#### Parameters

datetime | a GDateTime |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_to_utc ()

    GDateTime *
    g_date_time_to_utc (GDateTime *datetime);

Creates a new GDateTime corresponding to the same instant in time as `datetime` , but in UTC.

This call is equivalent to calling `g_date_time_to_timezone()` with the time zone returned by `g_time_zone_new_utc()`.

#### Parameters

datetime | a GDateTime |

#### Returns

the newly created GDateTime which should be freed with `g_date_time_unref()`, or `NULL`.

[transfer full][nullable]

Since: 2.26

### g_date_time_format ()

    gchar *
    g_date_time_format (GDateTime *datetime,
                        const gchar *format);

Creates a newly allocated string representing the requested `format` .

The format strings understood by this function are a subset of the `strftime()` format language as specified by C99. The %D, %U and %W conversions are not supported, nor is the 'E' modifier. The GNU extensions %k, %l, %s and %P are supported, however, as are the '0', '_' and '-' modifiers. The Python extension %f is also supported.

In contrast to `strftime()`, this function always produces a UTF-8 string, regardless of the current locale. Note that the rendering of many formats is locale-dependent and may not match the `strftime()` output exactly.

The following format specifiers are supported:

- %a: the abbreviated weekday name according to the current locale

- %A: the full weekday name according to the current locale

- %b: the abbreviated month name according to the current locale

- %B: the full month name according to the current locale

- %c: the preferred date and time representation for the current locale

- %C: the century number (year/100) as a 2-digit integer (00-99)

- %d: the day of the month as a decimal number (range 01 to 31)

- %e: the day of the month as a decimal number (range 1 to 31)

- %F: equivalent to `%Y-%m-%d` (the ISO 8601 date format)

- %g: the last two digits of the ISO 8601 week-based year as a decimal number (00-99). This works well with %V and %u.

- %G: the ISO 8601 week-based year as a decimal number. This works well with %V and %u.

- %h: equivalent to %b

- %H: the hour as a decimal number using a 24-hour clock (range 00 to 23)

- %I: the hour as a decimal number using a 12-hour clock (range 01 to 12)

- %j: the day of the year as a decimal number (range 001 to 366)

- %k: the hour (24-hour clock) as a decimal number (range 0 to 23); single digits are preceded by a blank

- %l: the hour (12-hour clock) as a decimal number (range 1 to 12); single digits are preceded by a blank

- %m: the month as a decimal number (range 01 to 12)

- %M: the minute as a decimal number (range 00 to 59)

- %f: the microsecond as a decimal number (range 000000 to 999999)

- %p: either "AM" or "PM" according to the given time value, or the corresponding strings for the current locale. Noon is treated as "PM" and midnight as "AM". Use of this format specifier is discouraged, as many locales have no concept of AM/PM formatting. Use %c or %X instead.

- %P: like %p but lowercase: "am" or "pm" or a corresponding string for the current locale. Use of this format specifier is discouraged, as many locales have no concept of AM/PM formatting. Use %c or %X instead.

- %r: the time in a.m. or p.m. notation. Use of this format specifier is discouraged, as many locales have no concept of AM/PM formatting. Use %c or %X instead.

- %R: the time in 24-hour notation (%H:%M)

- %s: the number of seconds since the Epoch, that is, since 1970-01-01 00:00:00 UTC

- %S: the second as a decimal number (range 00 to 60)

- %t: a tab character

- %T: the time in 24-hour notation with seconds (%H:%M:%S)

- %u: the ISO 8601 standard day of the week as a decimal, range 1 to 7, Monday being 1. This works well with %G and %V.

- %V: the ISO 8601 standard week number of the current year as a decimal number, range 01 to 53, where week 1 is the first week that has at least 4 days in the new year. See `g_date_time_get_week_of_year()`. This works well with %G and %u.

- %w: the day of the week as a decimal, range 0 to 6, Sunday being 0. This is not the ISO 8601 standard format -- use %u instead.

- %x: the preferred date representation for the current locale without the time

- %X: the preferred time representation for the current locale without the date

- %y: the year as a decimal number without the century

- %Y: the year as a decimal number including the century

- %z: the time zone as an offset from UTC (+hhmm)

- %:z: the time zone as an offset from UTC (+hh:mm). This is a gnulib `strftime()` extension. Since: 2.38

- %::z: the time zone as an offset from UTC (+hh:mm:ss). This is a gnulib `strftime()` extension. Since: 2.38

- %:::z: the time zone as an offset from UTC, with : to necessary precision (e.g., -04, +05:30). This is a gnulib `strftime()` extension. Since: 2.38

- %Z: the time zone or name or abbreviation

- %%: a literal % character

Some conversion specifications can be modified by preceding the conversion specifier by one or more modifier characters. The following modifiers are supported for many of the numeric conversions:

- O: Use alternative numeric symbols, if the current locale supports those.

- _: Pad a numeric result with spaces. This overrides the default padding for the specifier.

- -: Do not pad a numeric result. This overrides the default padding for the specifier.

- 0: Pad a numeric result with zeros. This overrides the default padding for the specifier.

Additionally, when O is used with B, b, or h, it produces the alternative form of a month name. The alternative form should be used when the month name is used without a day number (e.g., standalone). It is required in some languages (Baltic, Slavic, Greek, and more) due to their grammatical rules. For other languages there is no difference. %OB is a GNU and BSD `strftime()` extension expected to be added to the future POSIX specification, %Ob and %Oh are GNU `strftime()` extensions. Since: 2.56

#### Parameters

datetime | A GDateTime |
format | a valid UTF-8 string, containing the format for the GDateTime |

#### Returns

a newly allocated string formatted to the requested format or `NULL` in the case that there was an error (such as a format specifier not being supported in the current locale). The string should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.26

### g_date_time_format_iso8601 ()

    gchar *
    g_date_time_format_iso8601 (GDateTime *datetime);

Format `datetime` in ISO 8601 format, including the date, time and time zone, and return that as a UTF-8 encoded string.

Since GLib 2.66, this will output to sub-second precision if needed.

#### Parameters

datetime | A GDateTime |

#### Returns

a newly allocated string formatted in ISO 8601 format or `NULL` in the case that there was an error. The string should be freed with `g_free()`.

[transfer full][nullable]

Since: 2.62

## Types and Values

### GTimeSpan

    typedef gint64 GTimeSpan;

A value representing an interval of time, in microseconds.

Since: 2.26

### G_TIME_SPAN_DAY

    #define G_TIME_SPAN_DAY                 (G_GINT64_CONSTANT (86400000000))

Evaluates to a time span of one day.

Since: 2.26

### G_TIME_SPAN_HOUR

    #define G_TIME_SPAN_HOUR                (G_GINT64_CONSTANT (3600000000))

Evaluates to a time span of one hour.

Since: 2.26

### G_TIME_SPAN_MINUTE

    #define G_TIME_SPAN_MINUTE              (G_GINT64_CONSTANT (60000000))

Evaluates to a time span of one minute.

Since: 2.26

### G_TIME_SPAN_SECOND

    #define G_TIME_SPAN_SECOND              (G_GINT64_CONSTANT (1000000))

Evaluates to a time span of one second.

Since: 2.26

### G_TIME_SPAN_MILLISECOND

    #define G_TIME_SPAN_MILLISECOND         (G_GINT64_CONSTANT (1000))

Evaluates to a time span of one millisecond.

Since: 2.26

### GDateTime

    typedef struct _GDateTime GDateTime;

`GDateTime` is an opaque structure whose members cannot be accessed directly.

Since: 2.26

## See Also

GTimeZone